package Nix::Config;

use MIME::Base64;

$version = "1.11.6";

$binDir = $ENV{"NIX_BIN_DIR"} || "/nix/store/hca2hqcvwncf23hiqyqgwbsdy8vvl9xv-nix-1.11.6/bin";
$libexecDir = $ENV{"NIX_LIBEXEC_DIR"} || "/nix/store/hca2hqcvwncf23hiqyqgwbsdy8vvl9xv-nix-1.11.6/libexec";
$stateDir = $ENV{"NIX_STATE_DIR"} || "/nix/var/nix";
$manifestDir = $ENV{"NIX_MANIFESTS_DIR"} || "/nix/var/nix/manifests";
$logDir = $ENV{"NIX_LOG_DIR"} || "/nix/var/log/nix";
$confDir = $ENV{"NIX_CONF_DIR"} || "/etc/nix";
$storeDir = $ENV{"NIX_STORE_DIR"} || "/nix/store";

$bzip2 = "/nix/store/prp4x39l76ny28w2s1rlggcam7jsk177-bzip2-1.0.6.0.1-bin/bin/bzip2";
$xz = "/nix/store/37fvcfhlsnnji41mfv2bfsba83nv799c-xz-5.2.2-bin/bin/xz";
$curl = "/nix/store/asdn2vyqxxnicyw4s0rhblqwsvh3vx5w-curl-7.52.1-bin/bin/curl";
$openssl = "/nix/store/kb51yms6xqv16ffcaj1n0q7sa9yqrl5n-openssl-1.0.2j-bin/bin/openssl";

$useBindings = "yes" eq "yes";

%config = ();

%binaryCachePublicKeys = ();

$defaultPublicKeys = "cache.nixos.org-1:6NCHdD59X431o0gWypbMrAURkbJ16ZPMQFGspcDShjY=";

sub readConfig {
    if (defined $ENV{'_NIX_OPTIONS'}) {
        foreach my $s (split '\n', $ENV{'_NIX_OPTIONS'}) {
            my ($n, $v) = split '=', $s, 2;
            $config{$n} = $v;
        }
    } else {
        my $config = "$confDir/nix.conf";
        return unless -f $config;

        open CONFIG, "<$config" or die "cannot open ‘$config’";
        while (<CONFIG>) {
            /^\s*([\w\-\.]+)\s*=\s*(.*)$/ or next;
            $config{$1} = $2;
        }
        close CONFIG;
    }

    foreach my $s (split(/ /, $config{"binary-cache-public-keys"} // $defaultPublicKeys)) {
        my ($keyName, $publicKey) = split ":", $s;
        next unless defined $keyName && defined $publicKey;
        $binaryCachePublicKeys{$keyName} = decode_base64($publicKey);
    }
}

return 1;
