let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/54m4hrh98mshhl0nsvx826c0s0qvx3p3-perl-5.22.2/bin/perl";
  shell = "/nix/store/sciknmkzq2gfj46x337aqpblqsg0hbj7-bash-4.3-p48/bin/bash";
  coreutils = "/nix/store/9pn260ybk3gl3cc1ff6vxxajzqp7zk8j-coreutils-8.25/bin";
  bzip2 = "/nix/store/prp4x39l76ny28w2s1rlggcam7jsk177-bzip2-1.0.6.0.1-bin/bin/bzip2";
  gzip = "/nix/store/8s9hpb9xppxjz6n68am9fxyyipdklxzg-gzip-1.8/bin/gzip";
  xz = "/nix/store/37fvcfhlsnnji41mfv2bfsba83nv799c-xz-5.2.2-bin/bin/xz";
  tar = "/nix/store/pv3mc5c9vmrgylkh9339hzpjji5022d6-gnutar-1.29/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/9pn260ybk3gl3cc1ff6vxxajzqp7zk8j-coreutils-8.25/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/hca2hqcvwncf23hiqyqgwbsdy8vvl9xv-nix-1.11.6/bin";
  nixPrefix = "/nix/store/hca2hqcvwncf23hiqyqgwbsdy8vvl9xv-nix-1.11.6";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
